summaryrefslogtreecommitdiff
path: root/test
diff options
context:
space:
mode:
authorYu Watanabe <watanabe.yu+github@gmail.com>2019-03-15 20:26:45 +0900
committerYu Watanabe <watanabe.yu+github@gmail.com>2019-03-15 21:16:58 +0900
commit8cc6727a5a126266eb5582ccf85833e2acfeed62 (patch)
tree2deb1a905bd2f8ecb875db1d422d416d038fc2c2 /test
parentc6e892bc0eebe1d42c282bd2d8bae149fbeba85f (diff)
downloadsystemd-8cc6727a5a126266eb5582ccf85833e2acfeed62.tar.gz
test: add a testcase for device plugged -> dead -> plugged bug
Diffstat (limited to 'test')
l---------test/TEST-31-DEVICE-ENUMERATION/Makefile1
-rwxr-xr-xtest/TEST-31-DEVICE-ENUMERATION/test.sh49
-rwxr-xr-xtest/TEST-31-DEVICE-ENUMERATION/testsuite.sh12
3 files changed, 62 insertions, 0 deletions
diff --git a/test/TEST-31-DEVICE-ENUMERATION/Makefile b/test/TEST-31-DEVICE-ENUMERATION/Makefile
new file mode 120000
index 0000000000..e9f93b1104
--- /dev/null
+++ b/test/TEST-31-DEVICE-ENUMERATION/Makefile
@@ -0,0 +1 @@
+../TEST-01-BASIC/Makefile \ No newline at end of file
diff --git a/test/TEST-31-DEVICE-ENUMERATION/test.sh b/test/TEST-31-DEVICE-ENUMERATION/test.sh
new file mode 100755
index 0000000000..d7cea73361
--- /dev/null
+++ b/test/TEST-31-DEVICE-ENUMERATION/test.sh
@@ -0,0 +1,49 @@
+#!/bin/bash
+# -*- mode: shell-script; indent-tabs-mode: nil; sh-basic-offset: 4; -*-
+# ex: ts=8 sw=4 sts=4 et filetype=sh
+set -e
+TEST_DESCRIPTION="plugged -> dead -> plugged issue #11997"
+TEST_NO_NSPAWN=1
+
+. $TEST_BASE_DIR/test-functions
+QEMU_TIMEOUT=300
+
+test_setup() {
+ create_empty_image
+ mkdir -p $TESTDIR/root
+ mount ${LOOPDEV}p1 $TESTDIR/root
+
+ (
+ LOG_LEVEL=5
+ eval $(udevadm info --export --query=env --name=${LOOPDEV}p2)
+
+ setup_basic_environment
+
+ # mask some services that we do not want to run in these tests
+ ln -s /dev/null $initdir/etc/systemd/system/systemd-hwdb-update.service
+ ln -s /dev/null $initdir/etc/systemd/system/systemd-journal-catalog-update.service
+ ln -s /dev/null $initdir/etc/systemd/system/systemd-networkd.service
+ ln -s /dev/null $initdir/etc/systemd/system/systemd-networkd.socket
+ ln -s /dev/null $initdir/etc/systemd/system/systemd-resolved.service
+
+ # setup the testsuite service
+ cat >$initdir/etc/systemd/system/testsuite.service <<EOF
+[Unit]
+Description=Testsuite service
+
+[Service]
+ExecStart=/bin/bash -x /testsuite.sh
+Type=oneshot
+StandardOutput=tty
+StandardError=tty
+EOF
+ cp testsuite.sh $initdir/
+
+ setup_testsuite
+ ) || return 1
+
+ ddebug "umount $TESTDIR/root"
+ umount $TESTDIR/root
+}
+
+do_test "$@"
diff --git a/test/TEST-31-DEVICE-ENUMERATION/testsuite.sh b/test/TEST-31-DEVICE-ENUMERATION/testsuite.sh
new file mode 100755
index 0000000000..cb12b51bd2
--- /dev/null
+++ b/test/TEST-31-DEVICE-ENUMERATION/testsuite.sh
@@ -0,0 +1,12 @@
+#!/bin/bash
+# -*- mode: shell-script; indent-tabs-mode: nil; sh-basic-offset: 4; -*-
+# ex: ts=8 sw=4 sts=4 et filetype=sh
+set -ex
+set -o pipefail
+
+if journalctl -b | grep -e '\.device: Changed plugged -> dead'; then
+ exit 1
+fi
+
+echo OK > /testok
+exit 0